function pad(c) {
    var i = parseInt(c, 10);
    return (i < 10 ? '0' + i : c.toString());
}


var iSunriseSecondsSinceMidnight = 0;
var iSunsetSecondsSinceMidnight = 0;
var iDuskSecondsSinceMidnight = 0;
var iDawnSecondsSinceMidnight = 0;

function getAstroTimes() {
    if (iSunriseSecondsSinceMidnight!=0)
        return;
    var sunriseNode = Property.getNode('/config/geodata/sunrise');
    if (sunriseNode == null) {
        lWarn.logln('scheduleSunTimedEvents - no sunrise Infomation');
        return;
    }
    var sString = sunriseNode.getValue();
    var sArray = sString.split(':');
    if (sArray.length != 3) {
        lWarn.logln('scheduleSunTimedEvents - no sunrise Infomation');
        return;
    }
    iSunriseSecondsSinceMidnight = parseInt(sArray[2], 10);
    iSunriseSecondsSinceMidnight += parseInt(sArray[1], 10) * 60;
    iSunriseSecondsSinceMidnight += parseInt(sArray[0], 10) * 60 * 60;
    lInfo.logln('scheduleSunTimedEvents - sunrise at ' + sString + '; seconds since Midnight ' + iSunriseSecondsSinceMidnight);

    var sunsetNode = Property.getNode('/config/geodata/sunset');
    if (sunsetNode == null) {
        lWarn.logln('scheduleSunTimedEvents - no sunset Infomation');
        return;
    }
    sString = sunsetNode.getValue();
    sArray = sString.split(':');
    if (sArray.length != 3) {
        lWarn.logln('scheduleSunTimedEvents - no sunset Infomation');
        return;
    }
    iSunsetSecondsSinceMidnight = parseInt(sArray[2], 10);
    iSunsetSecondsSinceMidnight += parseInt(sArray[1], 10) * 60;
    iSunsetSecondsSinceMidnight += parseInt(sArray[0], 10) * 60 * 60;
    lInfo.logln('scheduleSunTimedEvents - sunset at ' + sString + '; seconds since Midnight ' + iSunsetSecondsSinceMidnight);

    var duskNode = Property.getNode('/config/geodata/civil_dusk');
    if (duskNode == null) {
        lWarn.logln('scheduleSunTimedEvents - no dusk Infomation');
        return;
    }
    sString = duskNode.getValue();
    sArray = sString.split(':');
    if (sArray.length != 3) {
        lWarn.logln('scheduleSunTimedEvents - no dusk Infomation');
        return;
    }
    iDuskSecondsSinceMidnight = parseInt(sArray[2], 10);
    iDuskSecondsSinceMidnight += parseInt(sArray[1], 10) * 60;
    iDuskSecondsSinceMidnight += parseInt(sArray[0], 10) * 60 * 60;
    lInfo.logln('scheduleSunTimedEvents - Dusk at ' + sString + '; seconds since Midnight ' + iDuskSecondsSinceMidnight);


    var dawnNode = Property.getNode('/config/geodata/civil_dawn');
    if (dawnNode == null) {
        lWarn.logln('scheduleSunTimedEvents - no dawn Infomation');
        return;
    }
    sString = dawnNode.getValue();
    sArray = sString.split(':');
    if (sArray.length != 3) {
        lWarn.logln('scheduleSunTimedEvents - no dawn Infomation');
        return;
    }
    iDawnSecondsSinceMidnight = parseInt(sArray[2], 10);
    iDawnSecondsSinceMidnight += parseInt(sArray[1], 10) * 60;
    iDawnSecondsSinceMidnight += parseInt(sArray[0], 10) * 60 * 60;
    lInfo.logln('scheduleSunTimedEvents - Dawn at ' + sString + '; seconds since Midnight ' + iDawnSecondsSinceMidnight);

} 

function deleteSunriseEvents() {
    lInfo.logln('deleteSunriseEvents');
    var aOldNotes = Property.getNode('dynamic/scheduledDynamicEvents');
    if (aOldNotes != null) {
        lInfo.logln('deleteTimedEvents - remove old');
        var queue = aOldNotes.getChildren();

        for ( var i = 0; i < queue.length; ++i) {
            var propNode = Property.getNode('/system/EventInterpreter/ScheduledEvents/' + queue[i].getValue());
            if (propNode) {
                propNode.getParent().removeChild(propNode);
            }
            lInfo.logln('deleteTimedEvents - remove old #' + i);
        }
    }
    var aOldNotes = Property.getNode('dynamic');
    if (aOldNotes != null)
        aOldNotes.removeChild('timedEvents_suntime');
}


function deleteTimedEvents() {
    lInfo.logln('deleteTimedEvents');
    var aOldNotes = Property.getNode('dynamic/scheduledFixedEvents');
    if (aOldNotes != null) {
        lInfo.logln('deleteTimedEvents - remove old');
        var queue = aOldNotes.getChildren();

        for ( var i = 0; i < queue.length; ++i) {
            var propNode = Property.getNode('/system/EventInterpreter/ScheduledEvents/' + queue[i].getValue());
            if (propNode) {
                propNode.getParent().removeChild(propNode);
            }
            lInfo.logln('deleteTimedEvents - remove old #' + i);
        }
    }
    var aOldNotes = Property.getNode('dynamic');
    if (aOldNotes != null)
        aOldNotes.removeChild('timedEvents' );
}

function resetOneEvent(path)
{
    if (Property.getNode(path)==null)
        return;
    var queueID = Property.getNode(path).getValue();
    var propNode = Property.getNode('/system/EventInterpreter/ScheduledEvents/' + queueID);
    if (propNode) {
        propNode.getParent().removeChild(propNode);
    }
    Property.getNode(path).getParent().removeChild(Property.getNode(path));
}

function setOneEvent(oEvent)
{
    getAstroTimes();
    lInfo.logln('queueTimedEvents - make: ' + oEvent.getPath());
    var dold = new Date();
    dold.setTime(dold.getTime() - (1000 * 60 * 60 * 24 * 7));
    var sRRule = "FREQ=DAILY;COUNT=1";

    
    if (oEvent.getChild('time/recurrenceBase').getValue() == 'absolute'){
        lInfo.logln('queueTimedEvents - it has a absolute time : ' + oEvent.getChild('time/date').getChildren()[0].getValue());                
        // erst mal nur ein statisches Datum (geht sowieso nicht mehr im UI aktuell
        dold = new Date(oEvent.getChild('time/date').getChildren()[0].getValue());
        lInfo.logln('starting ' + dold.getFullYear() + pad(dold.getMonth() + 1) + pad(dold.getDate()) );
    } else {        
        var oRecChildren = oEvent.getChild('time/recurrence').getChildren();
        if (oRecChildren != null) {
            for ( var jIndex = 0; jIndex < oRecChildren.length; jIndex++)
                if (jIndex != 0)
                    sRRule += "," + oRecChildren[jIndex].getValue();
                else
                    sRRule = "FREQ=WEEKLY;BYDAY=" + oRecChildren[jIndex].getValue();
        }
    }
    lInfo.logln('queueTimedEvents - recurrence rule is ' + sRRule);
    if (oEvent.getChild('time/timeBase').getValue() == 'daily') // nur statische Events hier
    {            
        resetOneEvent('dynamic/scheduledFixedEvents/' + oEvent.getChild('id').getValue());
        lInfo.logln('queueTimedEvents - it has a fixed time');

        var timeValue = Math.abs(oEvent.getChild('time/offset').getValue());


        var iCalStartTime = dold.getFullYear() + pad(dold.getMonth() + 1) + pad(dold.getDate()) + 'T' + pad(Math.floor(timeValue/3600))
                + pad(Math.floor(timeValue/60)%60) + pad(timeValue%60);

        lInfo.logln('queueTimedEvents - insert start : ' + iCalStartTime + ' rrule: ' + sRRule);

        var timerEvent = new TimedICalEvent('action_execute', iCalStartTime, sRRule, {
            path: oEvent.getPath()                           
        });
        Property.setProperty('dynamic/scheduledFixedEvents/' + oEvent.getChild('id').getValue(), timerEvent.raise());
    } else {
        resetOneEvent('dynamic/scheduledDynamicEvents/' + oEvent.getChild('id').getValue());
        lInfo.logln('queueTimedEvents - it has a fixed time');

        var timeValue = oEvent.getChild('time/offset').getValue();
        
        switch (oEvent.getChild('time/timeBase').getValue())
        {
            case 'sunrise':
                timeValue += iSunriseSecondsSinceMidnight;
            break;
            case 'sunset':
                timeValue += iSunsetSecondsSinceMidnight;
            break;
            case 'dusk':
                timeValue += iDuskSecondsSinceMidnight;
            break;
            case 'dawn':
                timeValue += iDawnSecondsSinceMidnight;
            break;
        }
        
        if (oEvent.getChild('time/limitBefore')!=null)
        {
            if (timeValue>oEvent.getChild('time/limitBefore').getValue())
                timeValue=oEvent.getChild('time/limitBefore').getValue();
        }
        if (oEvent.getChild('time/limitAfter')!=null)
        {
            if (timeValue<oEvent.getChild('time/limitAfter').getValue())
                timeValue=oEvent.getChild('time/limitAfter').getValue();
        }
        

        var iCalStartTime = dold.getFullYear() + pad(dold.getMonth() + 1) + pad(dold.getDate()) + 'T' + pad(Math.floor(timeValue/3600))
        + pad(Math.floor(timeValue/60)%60) + pad(timeValue%60);

        lInfo.logln('queueTimedEvents - insert start : ' + iCalStartTime + ' rrule: ' + sRRule);

        var timerEvent = new TimedICalEvent('action_execute', iCalStartTime, sRRule, {
            path: oEvent.getPath()                           
        });
        Property.setProperty('dynamic/scheduledDynamicEvents/' + oEvent.getChild('id').getValue(), timerEvent.raise());
    }    
}

function queueAllTimedEvents() {
    Property.load();
    getAstroTimes();
    lInfo.logln('queueStaticTimedEvents');
    var parentEvents = Property.getNode('entries');
    if (parentEvents != null) {
        var aEvents = parentEvents.getChildren();
        for ( var iIndex = 0; iIndex < aEvents.length; iIndex++) {            
            var oEvent = aEvents[iIndex];
            lInfo.logln('queueTimedEvents - adding #' + oEvent.getChild('id').getValue());
            setOneEvent(oEvent);
        }
    }
}

